# PixiJS Filters

[![Node.js CI](https://github.com/pixijs/filters/workflows/Node.js%20CI/badge.svg)](https://github.com/pixi.js/pixi-filters/actions?query=workflow%3A%22Node.js+CI%22) [![npm version](https://badge.fury.io/js/pixi-filters.svg)](https://badge.fury.io/js/pixi-filters)

PixiJS v7 optional display filters.

Filters include:

| Name                     | Package                                                                                            | Demo                                                                                           |
|--------------------------|----------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------------|
| **AdjustmentFilter**     | [@pixi/filter-adjustment](https://www.npmjs.com/package/@pixi/filter-adjustment)                   | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=AdjustmentFilter)     |
| **AdvancedBloomFilter**  | [@pixi/filter-advanced-bloom](https://www.npmjs.com/package/@pixi/filter-advanced-bloom)           | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=AdvancedBloomFilter)  |
| **AsciiFilter**          | [@pixi/filter-ascii](https://www.npmjs.com/package/@pixi/filter-ascii)                             | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=AsciiFilter)          |
| **BevelFilter**          | [@pixi/filter-bevel](https://www.npmjs.com/package/@pixi/filter-bevel)                             | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=BevelFilter)          |
| **BloomFilter**          | [@pixi/filter-bloom](https://www.npmjs.com/package/@pixi/filter-bloom)                             | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=BloomFilter)          |
| **BulgePinchFilter**     | [@pixi/filter-bulge-pinch](https://www.npmjs.com/package/@pixi/filter-bulge-pinch)                 | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=BulgePinchFilter)     |
| **ColorGradientFilter**  | [@pixi/filter-color-gradient](https://www.npmjs.com/package/@pixi/filter-color-gradient)           | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=ColorGradientFilter)  |
| **ColorMapFilter**       | [@pixi/filter-color-map](https://www.npmjs.com/package/@pixi/filter-color-map)                     | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=ColorMapFilter)       |
| **ColorOverlayFilter**   | [@pixi/filter-color-overlay](https://www.npmjs.com/package/@pixi/filter-color-overlay)             | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=ColorOverlayFilter)   |
| **ColorReplaceFilter**   | [@pixi/filter-color-replace](https://www.npmjs.com/package/@pixi/filter-color-replace)             | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=ColorReplaceFilter)   |
| **ConvolutionFilter**    | [@pixi/filter-convolution](https://www.npmjs.com/package/@pixi/filter-convolution)                 | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=ConvolutionFilter)    |
| **CrossHatchFilter**     | [@pixi/filter-cross-hatch](https://www.npmjs.com/package/@pixi/filter-cross-hatch)                 | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=CrossHatchFilter)     |
| **CRTFilter**            | [@pixi/filter-crt](https://www.npmjs.com/package/@pixi/filter-crt)                                 | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=CRTFilter)            |
| **DotFilter**            | [@pixi/filter-dot](https://www.npmjs.com/package/@pixi/filter-dot)                                 | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=DotFilter)            |
| **DropShadowFilter**     | [@pixi/filter-drop-shadow](https://www.npmjs.com/package/@pixi/filter-drop-shadow)                 | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=DropShadowFilter)     |
| **EmbossFilter**         | [@pixi/filter-emboss](https://www.npmjs.com/package/@pixi/filter-emboss)                           | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=EmbossFilter)         |
| **GlitchFilter**         | [@pixi/filter-glitch](https://www.npmjs.com/package/@pixi/filter-glitch)                           | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=GlitchFilter)         |
| **GlowFilter**           | [@pixi/filter-glow](https://www.npmjs.com/package/@pixi/filter-glow)                               | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=GlowFilter)           |
| **GodrayFilter**         | [@pixi/filter-godray](https://www.npmjs.com/package/@pixi/filter-godray)                           | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=GodrayFilter)         |
| **GrayscaleFilter**      | [@pixi/filter-grayscale](https://www.npmjs.com/package/@pixi/filter-grayscale)                     | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=GrayscaleFilter)      |
| **HslAdjustmentFilter**    | [@pixi/filter-hsl-adjustment](https://www.npmjs.com/package/@pixi/filter-hsl-adjustment)           | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=HslAdjustmentFilter)    |
| **KawaseBlurFilter**     | [@pixi/filter-kawase-blur](https://www.npmjs.com/package/@pixi/filter-kawase-blur)                 | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=KawaseBlurFilter)     |
| **MotionBlurFilter**     | [@pixi/filter-motion-blur](https://www.npmjs.com/package/@pixi/filter-motion-blur)                 | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=MotionBlurFilter)     |
| **MultiColorFilter**     | [@pixi/filter-multi-color-replace](https://www.npmjs.com/package/@pixi/filter-multi-color-replace) | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=MultiColorFilter)     |
| **OldFilmFilter**        | [@pixi/filter-old-film](https://www.npmjs.com/package/@pixi/filter-old-film)                       | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=OldFilmFilter)        |
| **OutlineFilter**        | [@pixi/filter-outline](https://www.npmjs.com/package/@pixi/filter-outline)                         | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=OutlineFilter)        |
| **PixelateFilter**       | [@pixi/filter-pixelate](https://www.npmjs.com/package/@pixi/filter-pixelate)                       | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=PixelateFilter)       |
| **RadialBlurFilter**     | [@pixi/filter-radial-blur](https://www.npmjs.com/package/@pixi/filter-radial-blur)                 | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=RadialBlurFilter)     |
| **ReflectionFilter**     | [@pixi/filter-reflection](https://www.npmjs.com/package/@pixi/filter-reflection)                   | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=ReflectionFilter)     |
| **RGBSplitFilter**       | [@pixi/filter-rgb](https://www.npmjs.com/package/@pixi/filter-rgb)                                 | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=RGBSplitFilter)       |
| **ShockwaveFilter**      | [@pixi/filter-shockwave](https://www.npmjs.com/package/@pixi/filter-shockwave)                     | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=ShockwaveFilter)      |
| **SimpleLightmapFilter** | [@pixi/filter-simple-lightmap](https://www.npmjs.com/package/@pixi/filter-simple-lightmap)         | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=SimpleLightmapFilter) |
| **TiltShiftFilter**      | [@pixi/filter-tilt-shift](https://www.npmjs.com/package/@pixi/filter-tilt-shift)                   | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=TiltShiftFilter)      |
| **TwistFilter**          | [@pixi/filter-twist](https://www.npmjs.com/package/@pixi/filter-twist)                             | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=TwistFilter)          |
| **ZoomBlurFilter**       | [@pixi/filter-zoom-blur](https://www.npmjs.com/package/@pixi/filter-zoom-blur)                     | [View demo](https://filters.pixijs.download/main/demo/index.html?enabled=ZoomBlurFilter)       |

## Examples

[View the PixiJS Filters Demo](https://pixijs.io/filters/tools/demo/) to interactively play with filters to see how they work.

## Installation

Using NPM:

```bash
npm install pixi-filters
```

Using Yarn:
```bash
yarn add pixi-filters
```

## Usage

### Bundler (Rollup, Webpack, etc)

Use imports to grab the specific filter to use. 

```js
import { DotFilter } from 'pixi-filters';

const filter = new DotFilter();
```

### Browser

Filters are automatically added to the `PIXI.filters` global namespace.

```html
<script src="pixi.min.js"></script>
<script src="pixi-filters.js"></script>
<script>
    const filter = new PIXI.filters.DotFilter();
</script>
```

## Documentation

API documention can be found [here](http://pixijs.github.io/pixi-filters/docs/).
